org.apache.commons.lang3.tuple

## Class Triple<L,M,R>

- java.lang.Object
- - org.apache.commons.lang3.tuple.Triple<L,M,R>

- Type Parameters:
    `L` - the left element type
    `M` - the middle element type
    `R` - the right element type
  All Implemented Interfaces:
    Serializable, Comparable<Triple<L,M,R>>
  Direct Known Subclasses:
    ImmutableTriple, MutableTriple

      public abstract class Triple<L,M,R>
      extends Object
      implements Comparable<Triple<L,M,R>>, Serializable

  A triple consisting of three elements.

  This class is an abstract implementation defining the basic API. It refers to the elements as 'left', 'middle' and 'right'.

  Subclass implementations may be mutable or immutable. However, there is no restriction on the type of the stored objects that may be stored. If mutable objects are stored in the triple, then the triple itself effectively becomes mutable.

  Since:
    3.2
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Triple<?,?,?>[]` | `EMPTY_ARRAY` An empty array.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Triple()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(Triple<L,M,R> other)` Compares the triple based on the left element, followed by the middle element, finally the right element.
    `static <L,M,R> Triple<L,M,R>[]` | `emptyArray()` Returns the empty array singleton that can be assigned without compiler warning.
    `boolean` | `equals(Object obj)` Compares this triple to another based on the three elements.
    `abstract L` | `getLeft()` Gets the left element from this triple.
    `abstract M` | `getMiddle()` Gets the middle element from this triple.
    `abstract R` | `getRight()` Gets the right element from this triple.
    `int` | `hashCode()` Returns a suitable hash code.
    `static <L,M,R> Triple<L,M,R>` | `of(L left, M middle, R right)` Obtains an immutable triple of three objects inferring the generic types.
    `static <L,M,R> Triple<L,M,R>` | `ofNonNull(L left, M middle, R right)` Obtains an immutable triple of three non-null objects inferring the generic types.
    `String` | `toString()` Returns a String representation of this triple using the format `($left,$middle,$right)`.
    `String` | `toString(String format)` Formats the receiver using the given format.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### EMPTY_ARRAY

          public static final Triple<?,?,?>[] EMPTY_ARRAY

      An empty array.

      Consider using `emptyArray()` to avoid generics warnings.

      Since:
        3.10.

  - ### Constructor Detail

    - #### Triple

          public Triple()

  - ### Method Detail

    - #### emptyArray

          public static <L,M,R> Triple<L,M,R>[] emptyArray()

      Returns the empty array singleton that can be assigned without compiler warning.
      Type Parameters:
        `L` - the left element type
        `M` - the middle element type
        `R` - the right element type
      Returns:
        the empty array singleton that can be assigned without compiler warning.
      Since:
        3.10.

    - #### of

          public static <L,M,R> Triple<L,M,R> of(L left,
                                                 M middle,
                                                 R right)

      Obtains an immutable triple of three objects inferring the generic types.

      This factory allows the triple to be created using inference to obtain the generic types.

      Type Parameters:
        `L` - the left element type
        `M` - the middle element type
        `R` - the right element type
      Parameters:
        `left` - the left element, may be null
        `middle` - the middle element, may be null
        `right` - the right element, may be null
      Returns:
        a triple formed from the three parameters, not null

    - #### ofNonNull

          public static <L,M,R> Triple<L,M,R> ofNonNull(L left,
                                                        M middle,
                                                        R right)

      Obtains an immutable triple of three non-null objects inferring the generic types.

      This factory allows the triple to be created using inference to obtain the generic types.

      Type Parameters:
        `L` - the left element type
        `M` - the middle element type
        `R` - the right element type
      Parameters:
        `left` - the left element, may not be null
        `middle` - the middle element, may not be null
        `right` - the right element, may not be null
      Returns:
        a triple formed from the three parameters, not null
      Throws:
        `NullPointerException` - if any input is null
      Since:
        3.13.0

    - #### compareTo

          public int compareTo(Triple<L,M,R> other)

      Compares the triple based on the left element, followed by the middle element, finally the right element. The types must be `Comparable`.
      Specified by:
        `compareTo` in interface `Comparable<Triple<L,M,R>>`
      Parameters:
        `other` - the other triple, not null
      Returns:
        negative if this is less, zero if equal, positive if greater

    - #### equals

          public boolean equals(Object obj)

      Compares this triple to another based on the three elements.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the object to compare to, null returns false
      Returns:
        true if the elements of the triple are equal

    - #### getLeft

          public abstract L getLeft()

      Gets the left element from this triple.
      Returns:
        the left element, may be null

    - #### getMiddle

          public abstract M getMiddle()

      Gets the middle element from this triple.
      Returns:
        the middle element, may be null

    - #### getRight

          public abstract R getRight()

      Gets the right element from this triple.
      Returns:
        the right element, may be null

    - #### hashCode

          public int hashCode()

      Returns a suitable hash code.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        the hash code

    - #### toString

          public String toString()

      Returns a String representation of this triple using the format `($left,$middle,$right)`.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string describing this object, not null

    - #### toString

          public String toString(String format)

      Formats the receiver using the given format.

      This uses `Formattable` to perform the formatting. Three variables may be used to embed the left and right elements. Use `%1$s` for the left element, `%2$s` for the middle and `%3$s` for the right element. The default format used by `toString()` is `(%1$s,%2$s,%3$s)`.

      Parameters:
        `format` - the format string, optionally containing `%1$s`, `%2$s` and `%3$s`, not null
      Returns:
        the formatted string, not null

Copyright © 2001–2023 The Apache Software Foundation. All rights reserved.